  MEMBER

  INCLUDE('rtfwriter.inc')

RTFFile                FILE,DRIVER('ASCII'),PRE(RTFF),CREATE,BINDABLE,THREAD
Record                     RECORD,PRE()
Rec                         STRING(8192)
                           END
                         END

RTFWriter.Construct       PROCEDURE
  CODE
    Self.FramesQ &= NEW(FramesQType)
    Self.FontsQ &= NEW(FontsQType)
    Self.ColorsQ &= NEW(ColorsQType)

RTFWriter.Destruct        PROCEDURE
  CODE
    free(Self.FramesQ)
    dispose(SELF.FramesQ)
    free(Self.FontsQ)
    dispose(SELF.FontsQ)
    free(Self.ColorsQ)
    dispose(SELF.ColorsQ)

RTFWriter.NewFile      PROCEDURE(filename_)
  CODE

    free(Self.FramesQ)
    clear(Self.FramesQ)
    free(Self.FontsQ)
    clear(Self.FontsQ)
    Self.FontsQ.Name='Arial'
    add(Self.FontsQ)

    free(Self.ColorsQ)
    clear(Self.ColorsQ)
    Self.ColorsQ.Color=0
    add(Self.ColorsQ)

    SELF.FileName=clip(filename_)

RTFWriter.SetDefaultFont      PROCEDURE(fontname_)
  CODE
    get(SELF.FontsQ,1)
    Self.FontsQ.Name=clip(fontname_)
    put(Self.FontsQ)

RTFWriter.AddFrame     PROCEDURE(text_,<type_>)
  CODE

    clear(SELF.FramesQ)
    if type_
      SELF.FramesQ.Text=text_
      SELF.FramesQ.FrameType=type_
    else
      loop i#=1 to len(clip(text_))
        if val(text_[i#])=13 then cycle.
        if val(text_[i#])=10 and val(text_[i#-1])=13
          j#+=6
          SELF.FramesQ.Text[j#-5 : j#]='\line '
        else
          if text_[i#]='{{' or text_[i#]='}' or text_[i#]='\'
            j#+=1
            SELF.FramesQ.Text[j#]='\'
          end
          j#+=1
          SELF.FramesQ.Text[j#]=text_[i#]
        end
      end
    end
    add(SELF.FramesQ)
    SELF.ActiveFrame=records(SELF.FramesQ)
    return SELF.ActiveFrame

RTFWriter.GetFrame     PROCEDURE(Num_)
  CODE
    if SELF.ActiveFrame<>Num_
      get(SELF.FramesQ,Num_)
      SELF.ActiveFrame=Num_
    end

RTFWriter.GetColor     PROCEDURE(Color_)
  CODE

    if Color_=COLOR:NONE then return -1.
    Self.ColorsQ.Color=Color_
    get(Self.ColorsQ,Self.ColorsQ.Color)
    if ~errorcode()
      return pointer(SELF.ColorsQ)
    else
      SELF.ColorsQ.Color=Color_
      add(SELF.ColorsQ)
      return records(SELF.ColorsQ)
    end

RTFWriter.SetNewPage  PROCEDURE(Num_)
  CODE
    SELF.GetFrame(Num_)
    SELF.FramesQ.NewPage=1
    put(SELF.FramesQ)

RTFWriter.SetFramePos  PROCEDURE(Num_,Xpos_,YPos_,Width_,Height_)
  CODE
    SELF.GetFrame(Num_)
    SELF.FramesQ.Xpos=round(Xpos_*20,1)
    SELF.FramesQ.YPos=round(YPos_*20,1)
    SELF.FramesQ.Width=round(Width_*20,1)
    SELF.FramesQ.Height=round(Height_*20,1)
    put(SELF.FramesQ)

RTFWriter.SetFrameFont PROCEDURE(Num_,FontName_,FontSize_,FontStyle_,FontColor_)
  CODE
    SELF.GetFrame(Num_)
    if clip(FontName_)<>''
      SELF.FontsQ.Name=clip(FontName_)
      get(SELF.FontsQ,SELF.FontsQ.Name)
      if ~errorcode()
        SELF.FramesQ.FontName=pointer(SELF.FontsQ)
      else
        SELF.FontsQ.Name=FontName_
        add(SELF.FontsQ)
        SELF.FramesQ.FontName=records(SELF.FontsQ)
      end
    else
      SELF.FramesQ.FontName=1
    end
    SELF.FramesQ.FontSize=FontSize_
    SELF.FramesQ.FontStyle=FontStyle_
    SELF.FramesQ.FontColor=SELF.GetColor(FontColor_)
    put(SELF.FramesQ)

RTFWriter.SetFrameAlign PROCEDURE(Num_,Align_)
  CODE
    SELF.GetFrame(Num_)
    SELF.FramesQ.Align=Align_
    put(SELF.FramesQ)

RTFWriter.SetFrameColor PROCEDURE(Num_,Backgroundcolor_)
  CODE
    SELF.GetFrame(Num_)
    SELF.FramesQ.Backgroundcolor=SELF.GetColor(Backgroundcolor_)
    put(SELF.FramesQ)

RTFWriter.SetFrameBorder PROCEDURE(Num_,BorderStyle_,BorderSize_,BorderColor_)
  CODE
    SELF.GetFrame(Num_)
    SELF.FramesQ.BorderStyle=BorderStyle_
    SELF.FramesQ.BorderSize=BorderSize_*20
    SELF.FramesQ.BorderColor=SELF.GetColor(BorderColor_)
    put(SELF.FramesQ)

RTFWriter.CreateFile   PROCEDURE
LOC:colorTmp   long
LOC:colorInb   byte,DIM(4),OVER(loc:colorTmp)
LOC:str       &STRING,AUTO

ImageFile         FILE,DRIVER('DOS'),PRE(IMF)
Record                   RECORD,PRE()
Byte                        STRING(1)
                         END
                     END

  CODE

    RTFFile{prop:name}=SELF.FileName
    create(RTFFile)
    open(RTFFile)
                  
    RTFF:Rec='{{\rtf1\ansi\ansicpg1251\deff0\deflang1049'

    do setpage
    add(RTFFile)

    RTFF:Rec='{{\fonttbl'
    loop i#=1 to records(SELF.FontsQ)
      get(SELF.FontsQ,i#)
      RTFF:Rec=clip(RTFF:Rec)&'{{\f' & i#-1 & '\fcharset204 ' & clip(SELF.FontsQ.name) & ';}'
    end
    RTFF:Rec=clip(RTFF:Rec) & '}'
    add(RTFFile)

    RTFF:Rec='{{\colortbl ;'
    loop i#=1 to records(SELF.ColorsQ)
      get(SELF.ColorsQ,i#)
      loc:colorTmp=SELF.ColorsQ.Color
      RTFF:Rec=clip(RTFF:Rec) & '\red' & loc:colorInb[1] & '\green' & loc:colorInb[2] & '\blue' & loc:colorInb[3] & ';'
    end
    RTFF:Rec=clip(RTFF:Rec) & '}'
    add(RTFFile)

    loop i#=1 to records(SELF.FramesQ)
      get(SELF.FramesQ,i#)


      if SELF.FramesQ.FrameType=1
        ImageFile{prop:name}=clip(SELF.FramesQ.Text)
        open(ImageFile,0)
        LOC:str &=NEW(STRING(records(ImageFile)*2))
        rec#=0
        set(ImageFile)
        loop
          next(ImageFile)
          if errorcode() then break.
          rec#+=1
          LOC:str[rec#*2-1 : rec#*2] = bytetohex(val(IMF:BYTE))
        end
        close(ImageFile)
        RTFF:Rec='\pard'&choose(SELF.FramesQ.NewPage=1,'\pagebb','')&'\plain{{\shp{{\*\shpinst\shpbxpage\shpbypage\shpleft'&SELF.FramesQ.XPos&'\shptop'&SELF.FramesQ.YPos&'\shpright'&SELF.FramesQ.Width+SELF.FramesQ.XPos&'\shpbottom'&SELF.FramesQ.Height+SELF.FramesQ.YPos
        add(RTFFile)
!        RTFF:Rec='{{\sp{{\sn shapeType}{{\sv 75}}{{\sp{{\sn pib}{{\sv {{\pict\picw'&SELF.FramesQ.Width&'\pich'&SELF.FramesQ.Height&'\picwgoal'&SELF.FramesQ.Width&'\pichgoal'&SELF.FramesQ.Height
        RTFF:Rec=''
!        if SELF.FramesQ.BorderStyle
!          get(SELF.ColorsQ,SELF.FramesQ.BorderColor)
!
!          if Band(SELF.FramesQ.BorderStyle,BorderLeft)
!            RTFF:Rec=clip(RTFF:Rec)&'{{\sp{{\sn borderLeftColor}{{\sv '&SELF.ColorsQ.Color&'}}'
!          end
!          if Band(SELF.FramesQ.BorderStyle,BorderRight)
!            RTFF:Rec=clip(RTFF:Rec)&'{{\sp{{\sn borderRightColor}{{\sv '&SELF.ColorsQ.Color&'}}'
!          end
!          if Band(SELF.FramesQ.BorderStyle,BorderTop)
!            RTFF:Rec=clip(RTFF:Rec)&'{{\sp{{\sn borderTopColor}{{\sv '&SELF.ColorsQ.Color&'}}'
!          end
!          if Band(SELF.FramesQ.BorderStyle,BorderBottom)
!            RTFF:Rec=clip(RTFF:Rec)&'{{\sp{{\sn borderBottomColor}{{\sv '&SELF.ColorsQ.Color&'}}'
!          end
!        end

        RTFF:Rec=clip(RTFF:Rec)&'{{\sp{{\sn shapeType}{{\sv 75}}{{\sp{{\sn pib}{{\sv {{\pict'

        l#=1
        case LOC:str[1:4]
        of '8950'
          RTFF:Rec=clip(RTFF:Rec)&'\pngblip'
        of 'FFD8'
          RTFF:Rec=clip(RTFF:Rec)&'\jpegblip'
!        of 'D7CD'
!          RTFF:Rec=clip(RTFF:Rec)&'\wmetafile'
        of '424D'
          RTFF:Rec=clip(RTFF:Rec)&'\dibitmap0'
          l#=29
        end
        if len(LOC:str)>128
          RTFF:Rec=clip(RTFF:Rec)&' '&LOC:str[l#:128]
          add(RTFFile)
          loop l#=129 to len(LOC:str) by 128
            if l#+127>len(LOC:str)
              RTFF:Rec=LOC:str[l# : len(LOC:str)]&'}}}}}'
            else
              RTFF:Rec=LOC:str[l# : l#+127]
            end
            add(RTFFile)
          end
        else
          RTFF:Rec=clip(RTFF:Rec)&' '&LOC:str[l# :  len(LOC:str)]&'}}}}}'
          add(RTFFile)
        end
        LOC:str=all('<0>')
        dispose(LOC:str)
      else
        RTFF:Rec='\pard'&choose(SELF.FramesQ.NewPage=1,'\pagebb','')&'\plain\overlay\phpg\pvpg'

        RTFF:Rec=clip(RTFF:Rec)&'\posx'&SELF.FramesQ.XPos
        RTFF:Rec=clip(RTFF:Rec)&'\posy'&SELF.FramesQ.YPos

        RTFF:Rec=clip(RTFF:Rec)&'\absw'&SELF.FramesQ.Width
        RTFF:Rec=clip(RTFF:Rec)&'\absh-'&SELF.FramesQ.Height

        RTFF:Rec=clip(RTFF:Rec)&'\f'&SELF.FramesQ.Fontname-1
        RTFF:Rec=clip(RTFF:Rec)&'\fs'&SELF.FramesQ.Fontsize*2
        if SELF.FramesQ.Fontcolor<>COLOR:NONE
          RTFF:Rec=clip(RTFF:Rec)&'\cf'&SELF.FramesQ.Fontcolor
        end

        if BAND(SELF.FramesQ.FontStyle,font:Bold)=font:Bold
          RTFF:Rec=clip(RTFF:Rec)&'\b'
        end
        if BAND(SELF.FramesQ.FontStyle,font:Italic)=font:Italic
          RTFF:Rec=clip(RTFF:Rec)&'\i'
        end
        if BAND(SELF.FramesQ.FontStyle,font:UnderLine)=font:UnderLine
          RTFF:Rec=clip(RTFF:Rec)&'\ul'
        end
        if BAND(SELF.FramesQ.FontStyle,font:Strikeout)=font:Strikeout
          RTFF:Rec=clip(RTFF:Rec)&'\strike'
        end

        execute SELF.FramesQ.Align
          RTFF:Rec=clip(RTFF:Rec)&'\ql'
          RTFF:Rec=clip(RTFF:Rec)&'\qr'
          RTFF:Rec=clip(RTFF:Rec)&'\qc'
        end 

        if SELF.FramesQ.BorderStyle=15
          RTFF:Rec=clip(RTFF:Rec)&'\box'
          RTFF:Rec=clip(RTFF:Rec)&'\brdrs'
          RTFF:Rec=clip(RTFF:Rec)&'\brdrw'& SELF.FramesQ.BorderSize
          if SELF.FramesQ.BorderColor<>COLOR:NONE
            RTFF:Rec=clip(RTFF:Rec)&'\brdrcf'& SELF.FramesQ.BorderColor
          end
        else
          if Band(SELF.FramesQ.BorderStyle,BorderLeft)
            RTFF:Rec=clip(RTFF:Rec)&'\brdrl'
            RTFF:Rec=clip(RTFF:Rec)&'\brdrs'
            RTFF:Rec=clip(RTFF:Rec)&'\brdrw'& SELF.FramesQ.BorderSize
            if SELF.FramesQ.BorderColor<>COLOR:NONE
              RTFF:Rec=clip(RTFF:Rec)&'\brdrcf'& SELF.FramesQ.BorderColor
            end
          end
          if Band(SELF.FramesQ.BorderStyle,BorderRight)
            RTFF:Rec=clip(RTFF:Rec)&'\brdrr'
            RTFF:Rec=clip(RTFF:Rec)&'\brdrs'
            RTFF:Rec=clip(RTFF:Rec)&'\brdrw'& SELF.FramesQ.BorderSize
            if SELF.FramesQ.BorderColor<>COLOR:NONE
              RTFF:Rec=clip(RTFF:Rec)&'\brdrcf'& SELF.FramesQ.BorderColor
            end
          end
          if Band(SELF.FramesQ.BorderStyle,BorderTop)
            RTFF:Rec=clip(RTFF:Rec)&'\brdrt'
            RTFF:Rec=clip(RTFF:Rec)&'\brdrs'
            RTFF:Rec=clip(RTFF:Rec)&'\brdrw'& SELF.FramesQ.BorderSize
            if SELF.FramesQ.BorderColor<>COLOR:NONE
              RTFF:Rec=clip(RTFF:Rec)&'\brdrcf'& SELF.FramesQ.BorderColor
            end
          end
          if Band(SELF.FramesQ.BorderStyle,BorderBottom)
            RTFF:Rec=clip(RTFF:Rec)&'\brdrb'
            RTFF:Rec=clip(RTFF:Rec)&'\brdrs'
            RTFF:Rec=clip(RTFF:Rec)&'\brdrw'& SELF.FramesQ.BorderSize
            if SELF.FramesQ.BorderColor<>COLOR:NONE
              RTFF:Rec=clip(RTFF:Rec)&'\brdrcf'& SELF.FramesQ.BorderColor
            end
          end
        end

        if SELF.FramesQ.BackGroundColor<>COLOR:NONE
          RTFF:Rec=clip(RTFF:Rec)&'\cbpat'&SELF.FramesQ.BackGroundColor
        end

        RTFF:Rec=clip(RTFF:Rec)&'{{'&clip(SELF.FramesQ.Text)&'}\par'
        add(RTFFile)
      end
    end

    RTFF:Rec='}'
    add(RTFFile)

    close(RTFFile)

setpage routine

    if SELF.PaperW
      RTFF:Rec=clip(RTFF:Rec)&'\paperw'&round(SELF.PaperW*56.7,1)
    end
    if SELF.PaperH
      RTFF:Rec=clip(RTFF:Rec)&'\paperh'&round(SELF.PaperH*56.7,1)
    end
    RTFF:Rec=clip(RTFF:Rec)&'\margl'&round(SELF.MarginL*56.7,1)
    RTFF:Rec=clip(RTFF:Rec)&'\margr'&round(SELF.MarginR*56.7,1)
    RTFF:Rec=clip(RTFF:Rec)&'\margt'&round(SELF.MarginT*56.7,1)
    RTFF:Rec=clip(RTFF:Rec)&'\margb'&round(SELF.MarginB*56.7,1)
    if SELF.Landscape
      RTFF:Rec=clip(RTFF:Rec)&'\landscape'
    end

